//
//  View.mm
//  GL
//
//  Created by NYU User on 11/30/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"
#import "GLViewController.h"

//functions defined in threedimensions.cpp
void up();
void down();
void left();
void right();
void forward();
void backward();

void panUp();
void panDown();
void panLeft();
void panRight();

@implementation View 


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame]) != nil) {
		// Initialization code
		static NSString *a[] = {
			@"↑",
			@"↓",
			@"←",
			@"→",
			@"for",
			@"bac",
			
			@"↑",
			@"↓",
			@"←",
			@"→"
		};

		viewController =
			[[GLViewController alloc] initWithNibName: nil bundle: nil];
		[self addSubview: viewController.view];
		
		n = sizeof button / sizeof button[0];
		CGRect b = self.bounds;
		CGFloat w = b.size.width / 10;

		for (size_t i = 0; i < n; ++i) {
			button[i] =
				[UIButton buttonWithType: UIButtonTypeRoundedRect];
			button[i].frame = CGRectMake(i * w, b.size.height - w, w, w);
			[button[i] setTitle: a[i] forState: UIControlStateNormal];
			[button[i] retain];

			[button[i] addTarget: self
				action: @selector(touchUpInside:)
				forControlEvents: UIControlEventTouchUpInside];

			[self addSubview: button[i]];
		}
	}
	return self;
}

- (void) touchUpInside: (id) sender {
	void (*a[])() = {	//array of pointers to functions
		up,
		down,
		left,
		right,
		forward,
		backward,
		
		panUp,
		panDown,
		panLeft,
		panRight
	};
	
	for (size_t i = 0; i < n; ++i) {
		if (sender == button[i]) {
			(*a[i])();
			break;
		}
	}	
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (void) dealloc {
	for (size_t i = 0; i < n; ++i) {
		[button[i] release];
	}

	[viewController release];
	[super dealloc];
}


@end
